% Obtain the cumulative distribution function value of each entry in a matrix.
% NAs are still NAs.
% Apply normalization for each row separately.
% Difference from get_cdf_values2: apply the sort function of matrix in matlab, instead of applying sort for each row separately.

function cdfvals = get_cdf_values2_version2(data)

[ngenes,nsamples]=size(data); clear cdfvals;

% Sort each row separately.
[YY,II]=sort(transpose(data)); YY=transpose(YY); II=transpose(II);

validlengths=sum((transpose(YY)>=0)|(transpose(YY)<0));
Zs=1./(validlengths-1);
masks=((YY>=0)|(YY<0));
arrays=YY;  maxval=max(arrays(:))+1; minval=min(arrays(:))-1;
larrays=100*ones(size(YY)); 
larrays=maxval*ones(size(YY));
larrays(find(~((larrays>=0)|(larrays<0))))=100;
rarrays=minval*ones(size(YY));
rarrays(:,2:nsamples)=arrays(:,1:(nsamples-1));
larraydiffs=(arrays<larrays);
rarraydiffs=(rarrays<arrays);
arraystarts=((larraydiffs==0)&(rarraydiffs==1)&(masks==1));
arrayends=((larraydiffs==1)&(rarraydiffs==0)&(masks==1));
tmpcdfvals=repmat(0:1:(nsamples-1),ngenes,1).*repmat(transpose(Zs),1,nsamples);
tmpcdfvals(find(masks==0))=NaN;

tstartsubset=find(transpose(arraystarts)==1);
tendsubset=find(transpose(arrayends)==1);
ttmpcdfvals=transpose(tmpcdfvals);

for i=1:length(tstartsubset)
i1=tstartsubset(i); i2=tendsubset(i);
ttmpcdfvals(i1:i2)=ttmpcdfvals(i1);
end
tmpcdfvals=transpose(ttmpcdfvals);

tcdfvals=transpose(NaN*ones(size(data)));
tII=transpose(II);
gtII=nsamples*repmat(0:1:(ngenes-1),nsamples,1);
gtII=gtII+tII;
tcdfvals(gtII)=ttmpcdfvals;
cdfvals=transpose(tcdfvals);




