% Obtain the cumulative distribution function value of each entry in a matrix.
% NAs are still NAs.
% Difference from get_cdf_values: accelerate the evaluation.

function cdfvals = get_cdf_values_version2(data)

cdfvals=NaN*ones(length(data(:,1)),length(data(1,:)));

tmpinds=find((data(:)>=0)|(data(:)<0)); tmpdata=data(:);
[YY,II]=sort(tmpdata(tmpinds));

Z=1/(length(tmpinds)-1); 
array=transpose(YY); 
larray(length(tmpinds))=100; larray(1:(length(tmpinds)-1))=array(2:length(tmpinds));
rarray(1)=-100; rarray(2:length(tmpinds))=array(1:(length(tmpinds)-1));
larraydiff=(array<larray);
rarraydiff=(rarray<array);
tmpcdfvals=0:Z:1; 
arraystart=zeros(1,length(tmpinds));
arraystart=((larraydiff==0)&(rarraydiff==1));
arraystart(1)=(YY(1)==YY(2));
arrayend=zeros(1,length(tmpinds));
arrayend=((larraydiff==1)&(rarraydiff==0));
arrayend(length(tmpinds))=(YY(length(tmpinds))==YY(length(tmpinds)-1));

startsubset=find(arraystart==1);
endsubset=find(arrayend==1);
for i=1:length(startsubset)
i1=startsubset(i); i2=endsubset(i);
tmpcdfvals(i1:i2)=tmpcdfvals(i1);
end

cdfvals(tmpinds(II))=tmpcdfvals;

