% Find the overlap of two intervals.

function ointerval = intervaloverlap(int1, int2)

a1=min(int1); b1=max(int1);
a2=min(int2); b2=max(int2);

ointerval=[];

% int1 is contained in int2.
if ((a1>=a2)&(a1<=b2)&(b1>=a2)&(b1<=b2))
ointerval=[a1 b1];

% int2 is contained in int1.
elseif ((a2>=a1)&(a2<=b1)&(b2>=a1)&(b2<=b1))
ointerval=[a2 b2];

% a1 is in [a2 b2] and b1 is not in [a2 b2].
elseif ((a1>=a2)&(a1<=b2)&(b1>b2))
ointerval=[a1 b2];

% a2 is in [a1 b1] and b2 is not in [a1 b1].
elseif ((a2>=a1)&(a2<=b1)&(b2>b1))
ointerval=[a2 b1];

% Otherwise int1 and int2 have no overlap.

end

