# include <stdio.h>
# include <stdlib.h>
# include <string.h>
# include <math.h>
# include <time.h>

// Data structure of a position weight matrix.
struct pwm {
  char *acc;  // Accession number.
  char *name; // Name.
  int  nbfs;  // Number of binding factors.
  char *bfs;  // Binding factor accession numbers.
  int  npos;  // Number of positions.
  double *mat; // Position weight matrix.  The nucleotide order is ACGT.
};

// Connected component.
struct component {
  int nmembers;  // Number of members.
  int *members;  // Members.
};

// Data structure of a pair of integers.
struct pair {
  int i;  // index 1.
  int j;  // index 2.
};

// Data structure of a triplet.
struct triplet {
  int i;  // index 1.
  int j;  // index 2.
  double s; // real value.
};

// Data structure of motifs under a factor.
struct facmotif {
  char *facacc;  // Factor accession number.
  char *facname; // Factor name.
  int  nmotifs;  // Number of motifs.
  char *motifaccs; // Motif accs.
  char *motifs;  // Motif sequences.  Use the following notations in addition to ATCG: R:GA, Y:CT, K:GT, M:AC, S:GC, W:AT, B:GTC, D:GAT, H:ACT, V:GCA, N:ACGT.
};

// Data structure of motifs.
struct motif {
  char *acc;     // Accession number.
  int nbfs;  // Number of factors.
  char *facaccs; // Factor accs.
  char *facnames; // Factor names.
  char *consensus; // Consensus sequence.
};


  
