% Calculate the log likelihood of a multinomial naive Bayes model.
% Simplified version of simple_loglikelihood.m in new_integration.
% Difference from naive_Bayes_loglikelihood.m: input data are fractional counts of tristates.

function ll = naive_Bayes_loglikelihood2(fraccnts)

[nsubvars,nstates]=size(fraccnts);

% Find the consensus of the states.
epsilon=1e-10; clear consensus;
totalcnts=sum(fraccnts); 
consensus=find(totalcnts>=max(totalcnts)); consensus=consensus(1);

% The conditional probability of P(probe=i|hidden state=j)=n(state=i)/#(probes).
thetas=totalcnts/sum(totalcnts);

if (length(fraccnts(:,1))==1)
thetas=fraccnts; totalcnts=fraccnts;
end

% Evaluate the log likelihood score.
ll=0;

ss=find(thetas>0);
tmpvals=zeros(1,length(thetas));

tmpvals(ss)=totalcnts(ss).*log(thetas(ss));

ii=find(tmpvals<=0);

ll=sum(tmpvals(ii));



